import{__decorate as t}from"../../_virtual/_tslib.js";import'./../../external/@lit/reactive-element/reactive-element.js';import{html as e}from'./../../external/lit-html/lit-html.js';import{LitElement as i}from'./../../external/lit-element/lit-element.js';import{customElement as o}from'./../../external/@lit/reactive-element/decorators/custom-element.js';import{property as s}from'./../../external/@lit/reactive-element/decorators/property.js';import{state as r}from'./../../external/@lit/reactive-element/decorators/state.js';import{query as n}from'./../../external/@lit/reactive-element/decorators/query.js';import'./../../external/@lit/reactive-element/decorators/query-assigned-elements.js';import{queryAssignedNodes as l}from'./../../external/@lit/reactive-element/decorators/query-assigned-nodes.js';import{ifDefined as d}from'./../../external/lit-html/directives/if-defined.js';import{classMap as a}from'./../../external/lit-html/directives/class-map.js';import{BUTTON_TYPES as p,BUTTON_KINDS as h,BUTTON_SIZES as m,BUTTON_ICON_POSITION as c}from"./defs.js";import u from"./button.scss.js";let y=class extends i{constructor(){super(...arguments),this.internals=this.attachInternals(),this.description="",this.type=p.BUTTON,this.kind=h.PRIMARY_APP,this.href="",this.size=m.MEDIUM,this.iconPosition=c.CENTER,this.disabled=!1,this.destructive=!1}render(){const t=this._slottedEls.filter((t=>""!==t.textContent.trim())),i={[h.PRIMARY_APP]:"primary-app",[h.PRIMARY_WEB]:"primary-web",[h.SECONDARY]:"secondary",[h.TERTIARY]:"tertiary"}[this.kind],o={button:!0,[`kd-btn--${i}${this.destructive?"-destructive":""}`]:!0,[`kd-btn--${i}`]:!this.destructive,"kd-btn--large":this.size===m.LARGE,"kd-btn--small":this.size===m.SMALL,"kd-btn--medium":this.size===m.MEDIUM,[`kd-btn--icon-${this.iconPosition}`]:!!this.iconPosition,"icon-only":this._iconEls.length&&!t.length};return e`
      ${""!==this.href?e`
            <a
              class=${a(o)}
              href=${this.href}
              ?disabled=${this.disabled}
              aria-label=${d(this.description||void 0)}
              title=${d(this.description||void 0)}
              @click=${t=>this.handleClick(t)}
            >
              <span>
                <slot @slotchange=${()=>this._handleSlotChange()}></slot>
                <slot
                  name="icon"
                  @slotchange=${()=>this._handleSlotChange()}
                ></slot>
              </span>
            </a>
          `:e`
            <button
              class=${a(o)}
              type=${this.type}
              ?disabled=${this.disabled}
              aria-label=${d(this.description||void 0)}
              title=${d(this.description||void 0)}
              value=${d(this.value)}
              formmethod=${d(this.formmethod)}
              @click=${t=>this.handleClick(t)}
            >
              <span>
                <slot @slotchange=${()=>this._handleSlotChange()}></slot>
                <slot
                  name="icon"
                  @slotchange=${()=>this._handleSlotChange()}
                ></slot>
              </span>
            </button>
          `}
    `}handleClick(t){this.internals.form&&("submit"===this.type?this.internals.form.requestSubmit(this._buttonEl):"reset"===this.type&&this.internals.form.reset());const e=new CustomEvent("on-click",{detail:{origEvent:t}});this.dispatchEvent(e)}_handleSlotChange(){this.requestUpdate()}firstUpdated(){this._handleSlotChange()}};y.styles=[u],y.formAssociated=!0,t([r()],y.prototype,"internals",void 0),t([s({type:String})],y.prototype,"description",void 0),t([s({type:String})],y.prototype,"type",void 0),t([s({type:String})],y.prototype,"kind",void 0),t([s({type:String})],y.prototype,"href",void 0),t([s({type:String})],y.prototype,"size",void 0),t([s({type:String})],y.prototype,"iconPosition",void 0),t([s({type:Boolean,reflect:!0})],y.prototype,"disabled",void 0),t([s({type:Boolean,reflect:!0})],y.prototype,"destructive",void 0),t([s({type:String})],y.prototype,"value",void 0),t([s({type:String})],y.prototype,"formmethod",void 0),t([l()],y.prototype,"_slottedEls",void 0),t([l({slot:"icon"})],y.prototype,"_iconEls",void 0),t([n(".button")],y.prototype,"_buttonEl",void 0),y=t([o("kd-button")],y);export{y as Button};
//# sourceMappingURL=button.js.map
